import { Component, OnInit } from '@angular/core';

import { ResourceService } from './resource.service';
import { IResource } from './resource';

@Component({
  selector: 'app-resource-list',
  templateUrl: './resource-list.component.html',
  styleUrls: ['./resource-list.component.css']
})
export class ResourceListComponent implements OnInit {

  constructor(private resourceService : ResourceService) { }

  errorMessage = '';
  resources: IResource[] = [];

  
  allowDrop(ev) {
    console.log("- allowDrop");
    ev.preventDefault();
  }
  
  drag(ev) {
    console.log("drag started -- "  );
    ev.dataTransfer.setData("text", ev.target.id);
  }
  
  drop(ev) {
    ev.preventDefault();
    var data = ev.dataTransfer.getData("text");
    ev.target.appendChild(document.getElementById(data));
  }
  
  ngOnInit(): void {
    console.log("- ngOnInit accessed...");
    this.resourceService.getResources().subscribe({
      next: resources => {
        this.resources = resources;
      },
    
      //error: err => console.log("error instance of ErrorEvent: " + (err instanceof ErrorEvent) )
      //error: err => console.log( "error type of: " + typeof(err) )    
      //error: err => console.log( "error has property " + err.hasOwnProperty("error") )    
      error: err => console.log( "error:" + err.error )    
  
    })

  }

}
