import { Component, OnInit } from '@angular/core';

import { UserService } from '../user-list/user.service';
import { IUser } from '../user-list/user';
import { UserResourcesService } from '../user-list/userResources.service';
import { IUserResources } from '../user-list/userResources';
import { HttpClient, HttpErrorResponse } from '@angular/common/http';


import { ResourceService } from '../resource-list/resource.service';
import { IResource } from '../resource-list/resource';


@Component({
  selector: 'app-resource-to-user-share',
  templateUrl: './resource-to-user-share.component.html',
  styleUrls: ['./resource-to-user-share.component.css']
})
export class ResourceToUserShareComponent implements OnInit {

    constructor(
      private userService : UserService,
      private userResourcesService: UserResourcesService,
      private http: HttpClient,
      private resourceService : ResourceService) { }

  errorMessage = '';
  users: IUser[] = [];

  userResources: IUserResources[] = [];
 
  //data:any = [];
  userResourcesData:  IUserResources[] = [];

  resources: IResource[] = [];

  linkForThisUserContent = "http://localhost:8080/package1_war_exploded/admin/user/bob1/resources";

  IdsArr : Array<string> = [];

  saveResources() {
    console.log("- save resources...");
    let myNodes = document.getElementById("user-file-location").children;
    console.log("- how many: " + myNodes.length);
    var myNodesArr = Array.from(myNodes);

    myNodesArr.forEach(myNode => {
      console.log("-id: " + myNode.id);
      this.IdsArr.push(myNode.id);
    });


    //this.http.post(this.linkForThisUserContent, this.IdsArr);  
    
    //const headers = { 'content-type': 'application/json'}  
    const headers = { 'content-type' : 'application/x-www-form-urlencoded'}
    //const body=JSON.stringify(person);
    //var Indata = {'product': 1, 'product2': 2 };
    this.http.post(this.linkForThisUserContent,
        //JSON.stringify(Indata),
        ("resourceIds=" + this.IdsArr),
        //Indata,
        {'headers':headers}
        )
        .subscribe(
        (val) => {
          console.log('POST call successful value returned in body',
            val);
        },
        response => {
          console.log('POST call in error', response);
        },
        () => {
          console.log('The POST observable is now completed.');
          this.IdsArr = [];
        });


    /*var seen = [];
    console.log(JSON.stringify(myNodes, function(key, val) {
      if (val != null && typeof val == "object") {
           if (seen.indexOf(val) >= 0) {
               return;
           }
           seen.push(val);
       }
       return val;
   })
    );*/

  }

  loadUserContent(getUser: string) {
    //alert("get user: " + getUser);


    this.users.forEach(user =>
      {
      document.getElementById(user.Username).style.backgroundColor = "white";
      document.getElementById(user.Username).style.fontSize = "17px";
      document.getElementById(user.Username).classList.remove('HoverClass1');
      document.getElementById(user.Username).classList.add('HoverClass1');
      }
      );
      
    document.getElementById(getUser).style.backgroundColor = "lightGreen";
    document.getElementById(getUser).style.fontSize = "20px";
    

    (document.getElementById("saveButton") as HTMLButtonElement).disabled=false;

    this.linkForThisUserContent = "http://localhost:8080/package1_war_exploded/admin/user/" + getUser + "/resources";
    //document.getElementById("user-file-location").innerHTML = "link: " + this.linkForThisUserContent;
    

    let e = this.userResourcesService.getTheObject(this.linkForThisUserContent);
    console.log("-e stringify: " + JSON.stringify(e));

    
    this.showUserResources(this.linkForThisUserContent)

    // clone the data object, using its known UserResource shape
    //.subscribe((userResourcesData: IUserResources[]) => this.userResources = { ...userResourcesData});


  }



  showUserResources(theUrl) {
    this.http.get(theUrl).subscribe((res) => {
      //this.data = res;
      this.userResourcesData = JSON.parse(JSON.stringify(res));
      //console.log("this data: " + JSON.stringify(this.data));
      console.log("this data: " + this.userResourcesData);

      //document.getElementById("user-file-location").innerHTML = "--" + theUrl + "--<br>";
      document.getElementById("user-file-location").innerHTML = "";
      this.userResourcesData.forEach(arrayItem =>
        {
          var resourceItem = document.createElement("div");
          resourceItem.id = arrayItem.Id.toString();
          resourceItem.className = "userResource";
          resourceItem.style.border="2px solid green";
          resourceItem.style.borderRadius="10px";
          resourceItem.style.padding="5px";        
          resourceItem.style.margin="5px";
          resourceItem.style.backgroundColor= "#F3F781";
          resourceItem.innerHTML = arrayItem.Name;

          if (arrayItem.Type == 'mp3') { resourceItem.innerHTML += "<img src='./assets/audio.png' style='margin:3px; vertical-align: middle; width:50px;'>" }
          if (arrayItem.Type == 'image') { resourceItem.innerHTML += "<img src='./assets/image.png' style='margin:3px; vertical-align: middle; width:50px;'>" }
          if (arrayItem.Type == 'video') { resourceItem.innerHTML += "<img src='./assets/video.png' style='margin:3px; vertical-align: middle; width:50px;'>" }
          if (arrayItem.Type == 'gif anim') { resourceItem.innerHTML += "<img src='./assets/gifanim.jpg' style='margin:3px; vertical-align: middle; width:50px;'>" }
          if (arrayItem.Type == 'pdf') { resourceItem.innerHTML += "<img src='./assets/pdf.png' style='margin:3px; vertical-align: middle; width:50px;'>" }
   

          document.getElementById("user-file-location").appendChild(resourceItem);
          
        })

        
      return this.userResourcesData;
    })
  }

  allowDrop(ev) {
    console.log("- allowDrop");
    ev.preventDefault();
  }
  
  drag(ev) {
    console.log("drag started -- "  );
    ev.dataTransfer.setData("text", ev.target.id);
  }
  
  drop(ev) {
    ev.preventDefault();
    var data = ev.dataTransfer.getData("text");
    ev.target.appendChild(document.getElementById(data));
  }

  ngOnInit(): void {
  

    console.log("- ngOnInit accessed...");
    this.userService.getUsers().subscribe({
      next: users => {
        this.users = users;
        
        
        //this.resources[0].resourceId=1; this.resources[0].resourceName="ketab1"; this.resources[0].resourceType="mp3";
        //console.log("- Resources 1 name: " + this.resources[0].resourceName);   
      },   
      error: err => console.log( "error:" + err.error )    
    })
    //console.log("error message: " + (err instanceof ErrorEvent) )

    let e = this.userResourcesService.getUserResource(this.linkForThisUserContent)
      // clone the data object, using its known UserResource shape
      //.subscribe((userResourcesData: IUserResources[]) => this.userResources = { ...userResourcesData});
      .subscribe({
        next: userResources => {this.userResources = userResources;}
      })



      this.resourceService.getResources().subscribe({
        next: resources => {
          this.resources = resources;
          
          
          //this.resources[0].resourceId=1; this.resources[0].resourceName="ketab1"; this.resources[0].resourceType="mp3";
          //console.log("- Resources 1 name: " + this.resources[0].resourceName);   
        },
        
        //error: err => console.log ("-there was an error: " + err.eeerrorMessage) //this.errorMessage = err
        //error: err => console.log ("-there was an error: " + err) //this.errorMessage = err
        //error: err => console.log("error instance of ErrorEvent: " + (err instanceof ErrorEvent) )
        //error: err => console.log( "error type of: " + typeof(err) )    
        //error: err => console.log( "error has property " + err.hasOwnProperty("error") )    
        error: err => console.log( "error:" + err.error )    
    
      })
      //console.log("error message: " + (err instanceof ErrorEvent) )
  
      
  }

}
