package com.mygrouptasks.thiscontent.controller;

//import com.mygrouptasks.thiscontent.config.UserDetailsServiceImpl;
import com.mygrouptasks.thiscontent.entities.*;
import com.mygrouptasks.thiscontent.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.*;

@RestController
@CrossOrigin(origins = {"http://localhost:4200"} )
public class UserController {

    @Autowired
    GroupService groupService;

    @Autowired
    CategoryService categoryService;

    @Autowired
    ResourceService resourceService;

    @Autowired
    UsersService usersService;

    /*part that can return
    @Autowired
    UserDetailsServiceImpl userDetailsServiceImpl;*/

    @GetMapping(value="admin/users", produces = "application/json")
    public List<Users> users()
    {
        return usersService.getAll();
    }

    @PostMapping(value="admin/user/{username}/resources", consumes = "application/x-www-form-urlencoded")
    //public void saveResourcesForUser(@RequestParam List<Integer> resourceIds)
    public void saveResourcesForUser(@PathVariable String username, @RequestParam String resourceIds)
    {
        System.out.println("-incoming Post request");
        System.out.println("-resource Ids received: " + resourceIds);
        String[] arrResourceIdsStr = resourceIds.split(",");

        /* to be completed: 1. convert to int, 2. convert to set. 3. on each item do a save if not in select *
        Set<String> mySet = new HashSet<String>();
        Collections.addAll(mySet, arrResourceIdsStr);
        mySet.forEach();
        Integer[arrResourceIdsStr.length] arrResourceIds;
        */
        for (int i=0; i<arrResourceIdsStr.length; i++) {
            System.out.println("- user <" + username + "> save resource with id <" + arrResourceIdsStr[i] + ">");
        }

    }

    @GetMapping(value="admin/user/{username}/resources", produces = "application/json")
    public List<Resource> resourcesForUser(@PathVariable String username)
    {
        return usersService.getResourceList(username);
    }

    @GetMapping(value="admin/groups/{groupid}/users", produces = "application/json")
    public List<Users> usersInGroup(@PathVariable int groupid)
    {
        return groupService.getAllUsersForGroup(groupid);
    }

    @GetMapping(value="admin/groups", produces = "application/json")
    public List<Group> groups()
    {
        return groupService.getGroups();
    }

    @GetMapping(value="admin/resources/user/{username}", produces = "application/json")
    public List<Resource> resourceForUser(@PathVariable String username)
    {
       return resourceService.getAllResourcesForUser(username);
    }

    @GetMapping(value="admin/resources/type/{type}", produces = "application/json")
    public List<Resource> resourcesOfType(@PathVariable String type) {
        return resourceService.getResourcesOfType(type);
    }

    @GetMapping(value="admin/resources", produces = "application/json")
    public List<Resource> resource() {
        return resourceService.getResources();
    }

    @GetMapping(value="admin/categories/{catid}/subcategories", produces = "application/json")
    public List<Category> subcategories(@PathVariable int catid) {
        return categoryService.getSubcategories(catid);
    }

    @GetMapping(value="admin/categories/top", produces = "application/json")
    public List<Category> topcategories() {
        return categoryService.getTopCategories();
    }

    @GetMapping(value="admin/categories", produces = "application/json")
    public List<Category> categories() {
        return categoryService.getCategories();
    }


    @PostMapping("/destroy")
    public String destroySession(HttpServletRequest request) {
        request.getSession().invalidate();
        return "redirect:/";
    }

    @PostMapping("/persistMessage")
    public String persistMessage(@RequestParam("msg") String msg, HttpServletRequest request) {
        @SuppressWarnings("unchecked")
        List<String> msgs = (List<String>) request.getSession().getAttribute("MY_SESSION_MESSAGES");
        if (msgs == null) {
            msgs = new ArrayList<>();
            request.getSession().setAttribute("MY_SESSION_MESSAGES", msgs);
        }
        msgs.add(msg);
        request.getSession().setAttribute("MY_SESSION_MESSAGES", msgs);
        return "redirect:/";
    }

    //session get or set
    @GetMapping("/")
    public String welcome (Model model, HttpSession session) {
        System.out.println("- start page here");

        String sessionUsername = (String) session.getAttribute("username");

        @SuppressWarnings("unchecked")
        List<String> messages = (List<String>) session.getAttribute("MY_SESSION_MESSAGES");

        if (messages==null) {
            messages = new ArrayList<>();
        }
        model.addAttribute("sessionUsername", sessionUsername);
        model.addAttribute("sessionMessages", messages);
        model.addAttribute("sessionId", session.getId());

        return "welcome";
    }

    @GetMapping("/checkusersservice")
    public void checkusersservice()
    {
        /*System.out.println("- accessing userDetailsServiceImpl with username <admin> returned: " +
                userDetailsServiceImpl.userDetailsServiceMethod("admin"));

         */
    }

    @GetMapping("/registeruser")
    public String registerWithBcrypt()
    {
        System.out.println("- register a user using bcrypt...");
        Users user1 = new Users();
        user1.setUsername("bob3");
        user1.setPassword("pass");
        user1.setEnabled(true);
        //usersService.saveUser(user1, "ROLE_USER");
        return "/registered";
    }

    @GetMapping("/loginSecureSuccess")
    public String loginSecureGet() {
        System.out.println("- log in get");
        return ("test");
    }


    @PostMapping("/loginSecure")
    public String loginPost() {
        System.out.println("- log in post");
        return ("userLoggedInPage");
    }

    @GetMapping("/login")
    public String login()
    {
        System.out.println("login...");
        return "/login";
    }

    @GetMapping("/user")
    public String user (Model model) {
        System.out.println("- user page here");
        return "userpage";
    }

    @GetMapping("/admin")
    public String admin (Model model) {
        System.out.println("- admin page here");
        return "admin";
    }

    @GetMapping("/403")
    public String error403() {
        return "/error/403";
    }


}
