package com.mygrouptasks.thiscontent.repository;

import com.mygrouptasks.thiscontent.entities.Resource;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ResourceRepository extends JpaRepository<Resource, Long> {

    @Query(value="select r from Resource r where r.id =:id")
    Resource getResourceById(@Param("id") int id);

    @Query(value="select * from resource", nativeQuery = true)
    List<Resource> getAll();

    @Query(value="select * from resource where type=?1", nativeQuery = true)
    List<Resource> getResourcesOfType(String type);
}
