package com.mygrouptasks.thiscontent.service;

import com.mygrouptasks.thiscontent.entities.Category;
import com.mygrouptasks.thiscontent.entities.Group;
import com.mygrouptasks.thiscontent.entities.GroupUser;
import com.mygrouptasks.thiscontent.entities.Users;
import com.mygrouptasks.thiscontent.repository.CategoryRepository;
import com.mygrouptasks.thiscontent.repository.GroupRepository;
import com.mygrouptasks.thiscontent.repository.GroupUserRepository;
import com.mygrouptasks.thiscontent.repository.UsersRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class GroupService {

    @Autowired
    GroupRepository groupRepository;

    @Autowired
    GroupUserRepository groupUserRepository;

    @Autowired
    UsersRepository usersRepository;

    public List<Group> getGroups() {
        List<Group> group = new ArrayList<>();
        return groupRepository.getAll();
    }

    public List<Users> getAllUsersForGroup(int groupid) {
        System.out.println("- at getAllUsersForGroup...");
        List<Users> u = new ArrayList<>();
        List<String> un = groupUserRepository.getUsernamesForGroup(groupid); //getUserResourceOwnershipsForUser(username);
        System.out.println("- get users for group id '" + groupid + "'...");
        un.forEach(un1 -> u.add( usersRepository.findByUsername(un1)));
        if (u.size() > 0) {
            System.out.println("first user for group id '" + groupid + "' in u:" + u.get(0).getUsername());
        } else { System.out.println("no user for group id '" + groupid + "'"); }
        return u;
    }

}
