package com.mygrouptasks.thiscontent.service;

import com.mygrouptasks.thiscontent.entities.Resource;
import com.mygrouptasks.thiscontent.entities.UserResource;
import com.mygrouptasks.thiscontent.repository.ResourceRepository;
import com.mygrouptasks.thiscontent.repository.UserResourceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class ResourceService {

    @Autowired
    UserResourceRepository userResourceRepository;

    @Autowired
    ResourceRepository resourceRepository;

    public List<Resource> getResources() {
        List<Resource> resources = new ArrayList<>();
        return resourceRepository.getAll();
    }

    public List<Resource> getAllResourcesForUser(String username) {
        System.out.println("- at getAllResourcesForUser...");
        List<Resource> r = new ArrayList<>();
        //List<UserResourceOwnership> uro = userResourceOwnershipRepository.getAll(); //getUserResourceOwnershipsForUser(username);
        //System.out.println("- get all...");
        List<UserResource> uro = userResourceRepository.getUserResourcesForUser(username); //getUserResourceOwnershipsForUser(username);
        System.out.println("- get for username '" + username + "'...");

        System.out.println("- uro is set");
        uro.forEach(ur -> r.add( resourceRepository.getResourceById(ur.getResourceid())));
        if (r.size() > 0) {
            System.out.println("first resource name for '" + username + "' in r:" + r.get(0).getName());
        } else { System.out.println("no resource item for username '" + username + "'"); }
        return r;
    }

    public List<Resource> getResourcesOfType(String type) {
        return resourceRepository.getResourcesOfType(type);
    }
}