package com.mygrouptasks.thiscontent.service;

import com.mygrouptasks.thiscontent.entities.Resource;
import com.mygrouptasks.thiscontent.entities.UserResource;
import com.mygrouptasks.thiscontent.entities.Users;
import com.mygrouptasks.thiscontent.repository.AuthoritiesRepository;
import com.mygrouptasks.thiscontent.repository.ResourceRepository;
import com.mygrouptasks.thiscontent.repository.UserResourceRepository;
import com.mygrouptasks.thiscontent.repository.UsersRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
//import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
//@Component
public class UsersService {

    //@Autowired
    //private PasswordEncoder passwordEncoder;

    @Autowired
    private UsersRepository usersRepository;

    @Autowired
    private AuthoritiesRepository authoritiesRepository;

    @Autowired
    private AuthoritiesService authoritiesService;

    @Autowired
    private UserResourceRepository userResourceRepository;

    @Autowired
    private ResourceRepository resourceRepository;

    /*can return
    public void saveUser(Users user, String role) {
        user.setPassword(passwordEncoder.encode(user.getPassword()));
        usersRepository.save(user);
        authoritiesService.saveAuthority(user.getUsername(), role);
        //authoritiesRepository.insertIntoAuthorities(user.getUsername(),role);
        System.out.println("- user saved.");
    }*/

    /*public Users returnById (int user_id) {
        Users thisUser = usersRepository.findById(user_id);
        return thisUser;
    }*/

    public List<Users> getAll() {
        return usersRepository.getAll();
    }

    public List<Resource> getResourceList (String username) {
        List<UserResource> userResourceRepoList = userResourceRepository.getUserResourcesForUser(username);
        List<Resource> userResources = new ArrayList<>();
        userResourceRepoList.forEach(urrl -> userResources.add(
                resourceRepository.getResourceById(urrl.getResourceid())));
        return userResources;
    }

    public Users returnByUsername (String username) {
        Users thisUser = usersRepository.findByUsername(username);
        System.out.println("- finding and returning user: < " + thisUser.getUsername() + " >");
        return thisUser;
    }

}
